#!/bin/bash

# release or dev
TAG=$1
# latest or latest-dev (or a specific version)
BINARIES_IMAGE=$2
# passed as komodo variable
KOMODO_VERSION=$3
# passed as komodo variable
KOMODO_GIT_TOKEN=$4

echo "Tag: ${TAG}"
echo "Image: ${BINARIES_IMAGE}"
echo "Version: ${KOMODO_VERSION}"

X86_64_IMAGE=$BINARIES_IMAGE-x86_64
AARCH64_IMAGE=$BINARIES_IMAGE-aarch64

docker pull $X86_64_IMAGE
docker pull $AARCH64_IMAGE

x86_64_id=$(docker create $X86_64_IMAGE sh)
aarch64_id=$(docker create $AARCH64_IMAGE sh)


## CORE
docker cp $x86_64_id:/core ./core-x86_64
curl --user mbecker20:$KOMODO_GIT_TOKEN \
    --upload-file ./core-x86_64 \
    https://git.komo.do/api/packages/komodo/generic/core/$KOMODO_VERSION-$TAG/core-x86_64
docker cp $aarch64_id:/core ./core-aarch64
curl --user mbecker20:$KOMODO_GIT_TOKEN \
    --upload-file ./core-aarch64 \
    https://git.komo.do/api/packages/komodo/generic/core/$KOMODO_VERSION-$TAG/core-aarch64

## PERIPHERY
docker cp $x86_64_id:/periphery ./periphery-x86_64
curl --user mbecker20:$KOMODO_GIT_TOKEN \
    --upload-file ./periphery-x86_64 \
    https://git.komo.do/api/packages/komodo/generic/periphery/$KOMODO_VERSION-$TAG/periphery-x86_64
docker cp $aarch64_id:/periphery ./periphery-aarch64
curl --user mbecker20:$KOMODO_GIT_TOKEN \
    --upload-file ./periphery-aarch64 \
    https://git.komo.do/api/packages/komodo/generic/periphery/$KOMODO_VERSION-$TAG/periphery-aarch64

## UTIL
docker cp $x86_64_id:/util ./util-x86_64
curl --user mbecker20:$KOMODO_GIT_TOKEN \
    --upload-file ./util-x86_64 \
    https://git.komo.do/api/packages/komodo/generic/util/$KOMODO_VERSION-$TAG/util-x86_64
docker cp $aarch64_id:/util ./util-aarch64
curl --user mbecker20:$KOMODO_GIT_TOKEN \
    --upload-file ./util-aarch64 \
    https://git.komo.do/api/packages/komodo/generic/util/$KOMODO_VERSION-$TAG/util-aarch64

docker container rm $x86_64_id
docker container rm $aarch64_id